<?php

/**
* @file
* Contains \Drupal\locker\Form\unlockForm
*/
namespace Drupal\locker\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Entity\EntityInterface;

class UnlockForm extends ConfigFormBase {

    public function getFormId() {
        return 'locker-unlock-form';
    }

    protected function getEditableConfigNames() {
        return ['locker.login'];
    }

    public function buildForm(array $form, FormStateInterface $form_state, EntityInterface $node = NULL) {
        $config = $this->config('locker.settings');
        $locker_access_options = $config->get('locker_access_options');

        if ($locker_access_options == 'user_pass') {
            $form['username'] = array(
                '#type' => 'textfield',
                '#attributes' => array('placeholder' => $this->t('Username')),
            );

            $form['password'] = array(
                '#type' => 'password',
                '#attributes' => array('placeholder' => $this->t('Password')),
            );
        } elseif ($locker_access_options == 'passphrase') {
            $form['passphrase'] = array(
                '#type' => 'password',
                '#attributes' => array('placeholder' => $this->t('Passphrase')),
            );
        }

        $form['submit'] = array(
            //'#prefix' => '<div class="js-form-item form-item js-form-type-textfield form-type-textfield js-form-item-username form-item-username form-no-label">', '#sufix' => '</div>',
            '#type' => 'submit',
            '#attributes' => array('class' => array('form-submit'), 'style' => ''),
            '#value' => $this->t('Login'),
        );

        $form['developed'] = array(
            '#markup' => '<p>Developed by <a href="http://www.websolutions.hr/">WEBSOLUTIONS | HR</a></p>',
        );

        return parent::buildForm($form, $form_state);
    }

    public function submitForm(array &$form, FormStateInterface $form_state) {

        global $base_url;
        $unlocked = false;

        //getConfig Readonly
        $config = $this->config('locker.settings'); //$config = \Drupal::config('locker.settings');
        //getConfig Read/Write
        //$config = \Drupal::service('config.factory')->getEditable('locker.settings');

        $locker_access_options = $config->get('locker_access_options');

        if($locker_access_options  == 'user_pass') {
            $user_unlock = $form_state->getValue('username');
            $pass_unlock = $form_state->getValue('password');
            $password_unlock = $config->get('locker_password');
            $username_unlock = $config->get('locker_user');
            if ($user_unlock == $username_unlock AND md5($pass_unlock) == $password_unlock) {
                $unlocked = true;
            }
        }
        elseif($locker_access_options == 'passphrase') {
            $passphrase = $form_state->getValue('passphrase');
            $passphrase_unlock = $config->get('locker_passphrase');
            if(md5($passphrase) == $passphrase_unlock) {
                $unlocked = true;
            }
        }

        if ($unlocked) {
            $_SESSION['locker_unlocked'] = 'yes';
            //variable_del('locker_login_error', NULL);
            \Drupal::state()->delete('locker_login_error');
        }
        else {
            //variable_set('locker_login_error', 'yes');
            \Drupal::state()->set('locker_login_error', 'yes');
        }

        parent::submitForm($form, $form_state);
    }
}
